﻿using System;
using Android.App;
using Android.Content;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;

namespace AndroidLogic
{
    [Activity(Label = "AndroidLogic", MainLauncher = true, Icon = "@drawable/icon")]
    public class MainActivity : Activity
    {        
        EditText txtInput = null;
        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);

            // Set our view from the "main" layout resource
            SetContentView(Resource.Layout.Main);

            // Get our button from the layout resource,
            // and attach an event to it
            FindViewById<Button>(Resource.Id.btnCalculate).Click += btnCalculate_Click;
            FindViewById<Button>(Resource.Id.btnAnd).Click += btnAnd_Click;
            FindViewById<Button>(Resource.Id.btnBut).Click += btnBut_Click;
            FindViewById<Button>(Resource.Id.btnEquals).Click += btnEquals_Click;
            FindViewById<Button>(Resource.Id.btnNot).Click += btnNot_Click;
            FindViewById<Button>(Resource.Id.btnOr).Click += btnOr_Click;
            FindViewById<Button>(Resource.Id.btnThen).Click += btnThen_Click;
            FindViewById<Button>(Resource.Id.btnTotology).Click += btnTotology_Click;
            FindViewById<Button>(Resource.Id.btnAbout).Click += MainActivity_Click;
            txtInput = FindViewById<EditText>(Resource.Id.txtInput);
            txtInput.TextAlignment = TextAlignment.Center;
            txtInput.AfterTextChanged += TxtInput_AfterTextChanged;
            
        }

        private void MainActivity_Click(object sender, EventArgs e)
        {
            var str = @"گزاره مورد نظر را وارد کرده و محاسبه را بزنید
معادل اوپراتور های منطقی عبارتند از 
And &
Or |
Not !
Then >
If Only If =
But B
!B : T
Atomics  : Positive Numbers {1,2,3 , . . .}

Example : (1>2)=(!1|2)   for (A=>B) <=> (!A|B)

برنامه نویس : مجتبی گودرزی
m.goodarzi.73@ut.ac.ir

استاد راهنما : دکتر مجتهدی";
            MessageBox(str, "");
        }

        private void TxtInput_AfterTextChanged(object sender, Android.Text.AfterTextChangedEventArgs e)
        {
            txtInput.SetSelection(  txtInput.Text.Length);
        }

        private void btnBut_Click(object sender, EventArgs e)
        {
            txtInput.Text += "B";            
        }

        private void btnTotology_Click(object sender, EventArgs e)
        {
            txtInput.Text += "T";
        }

        private void btnThen_Click(object sender, EventArgs e)
        {
            txtInput.Text += ">";
        }

        private void btnOr_Click(object sender, EventArgs e)
        {
            txtInput.Text += "|";
        }

        private void btnNot_Click(object sender, EventArgs e)
        {
            txtInput.Text += "!";
        }

        private void btnEquals_Click(object sender, EventArgs e)
        {
            txtInput.Text += "=";
        }



        private void btnAnd_Click(object sender, EventArgs e)
        {
            txtInput.Text += "&";
        }

        private void btnCalculate_Click(object sender, EventArgs e)
        {
            try
            {
                var a = Logic.CalculateFormula.IsTotology(txtInput.Text);
                if(a.Item1)
                    MessageBox($"{txtInput.Text} is always true", "همانگو");
                else
                    MessageBox($"{txtInput.Text} is false for {a.Item2}", "همانگو نیست");
            }
            catch(Exception)
            {

                txtInput.Text = "";
            }
        }

        private void MessageBox(string content , string title)
        {
            AlertDialog.Builder dlgAlert = new AlertDialog.Builder(this);
            dlgAlert.SetMessage(content);
            dlgAlert.SetTitle(title);
            dlgAlert.SetPositiveButton("OK", (e,r)=> {
                dlgAlert.Dispose();
            });
            dlgAlert.SetCancelable(true);
            dlgAlert.Create().Show();

            
        }
    }
}

