﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Popups;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=391641

namespace WindowsPhoneLogic
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();

            this.NavigationCacheMode = NavigationCacheMode.Required;
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.
        /// This parameter is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            // TODO: Prepare page for display here.
            txtInput.TextChanged += TxtInput_TextChanged;
            // TODO: If your application contains multiple pages, ensure that you are
            // handling the hardware Back button by registering for the
            // Windows.Phone.UI.Input.HardwareButtons.BackPressed event.
            // If you are using the NavigationHelper provided by some templates,
            // this event is handled for you.
        }

        private void TxtInput_TextChanged(object sender, TextChangedEventArgs e)
        {
            txtInput.Focus(FocusState.Keyboard);
            txtInput.SelectionStart = txtInput.Text.Length;            
        }

        private void btnCalculate_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                var a = Logic.CalculateFormula.IsTotology(txtInput.Text);
                if(a.Item1)
                {
                    new MessageDialog($"{txtInput.Text} is always true", "همانگو").ShowAsync();
                }
                else
                {
                    new MessageDialog($"{txtInput.Text} is false for : {a.Item2}", "همانگو نیست").ShowAsync();
                }
            }
            catch(Exception ex)
            {
                txtInput.Text = "";
            }
        }

        private void btnAdd_Click(object sender, RoutedEventArgs e)
        {
            txtInput.Text = txtInput.Text.Insert(txtInput.SelectionStart, "&");
        }

        private void btnOr_Click(object sender, RoutedEventArgs e)
        {
            txtInput.Text = txtInput.Text.Insert(txtInput.SelectionStart, "|");
        }

        private void btnNot_Click(object sender, RoutedEventArgs e)
        {
            txtInput.Text= txtInput.Text.Insert(txtInput.SelectionStart, "!");
        }

        private void btnArrow_Click(object sender, RoutedEventArgs e)
        {
            txtInput.Text= txtInput.Text.Insert(txtInput.SelectionStart, ">");
        }

        private void btnBut_Click(object sender, RoutedEventArgs e)
        {
            txtInput.Text = txtInput.Text.Insert(txtInput.SelectionStart, "B");
        }

        private void btnTotology_Click(object sender, RoutedEventArgs e)
        {
            txtInput.Text = txtInput.Text.Insert(txtInput.SelectionStart, "T");
        }

        private void btnEquals_Click(object sender, RoutedEventArgs e)
        {
            txtInput.Text = txtInput.Text.Insert(txtInput.SelectionStart, "=");
        }
    }
}